#include <stdio.h>

#define N 16

void init_array(double * array, int len){
    for (int i=0; i<len; i++){
        array[i] = (double) i;
    }
}

void print_array(double * array, int len){
    printf("[ ");
    for (int i=0; i<len; i++){
        printf("%lf ", array[i]);
    }
    printf("]\n");
}

void seq_normalize(double * array, int len){
    double length_squared=0;
    for (int i=0; i<len; i++){
        length_squared += array[i] * array[i];
    }

    double inv_length_squared = 1 / length_squared;
        
    for (int i=0; i<len; i++){
        array[i] *= inv_length_squared;
    }
}

int main(int argc, char * argv[]){

    double array[N];

    init_array(array, N);
    print_array(array, N);
    seq_normalize(array, N);
    print_array(array, N);

    return 0;
}
